apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: {{ include "app-service.fullname" . }}-ingress
  namespace: {{ include "app-service.namespace" . }}
  labels:
    {{- include "app-service.labels" . | nindent 4 }}
  annotations:
    nginx.ingress.kubernetes.io/use-regex: "true"
    nginx.ingress.kubernetes.io/backend-protocol: "HTTPS"
    nginx.ingress.kubernetes.io/configuration-snippet: |
      more_set_headers "X-Content-Type-Options: nosniff";
      more_set_headers "X-Frame-Options: SAMEORIGIN";
      more_set_headers "Content-Security-Policy: default-src 'self'";
      more_set_headers "Content-Security-Policy: script-src 'self' 'unsafe-inline'";
      more_set_headers "Referrer-Policy: no-referrer-when-downgrade";
      more_set_headers "Permissions-Policy: microphone=(), geolocation=(), camera=()";
      limit_req zone=request_limit_api_second burst=20 nodelay;
      limit_req zone=request_limit_api_minute burst=20 nodelay;

spec:
  ingressClassName: {{ include "ingress.class.name" . }}
  rules:
  - host: {{ .Values.fqdn }}
    http:
      paths:
        - path: /api/v1/app-service/openapi
          pathType: Prefix
          backend:
            service:
              name: {{ include "app-service.service.name" $ }}
              port:
                number: {{ $.Values.ports.apiTarget }}
        - path: /api/v1/app-service/swagger-ui
          pathType: Prefix
          backend:
            service:
              name: {{ include "app-service.service.name" $ }}
              port:
                number: {{ $.Values.ports.apiTarget }}
        - path: /api/v1/app-service/apps(.*$)
          pathType: ImplementationSpecific
          backend:
            service:
              name: {{ include "app-service.service.name" $ }}
              port:
                number: {{ $.Values.ports.apiTarget }}
